// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "Camera.hpp"

namespace Dawn {
  class PixelPerfectCamera : public SceneItemComponent {
    protected:
      std::function<void()> teardown;
      
      /**
       * Updates the underlying camera's projection information.
       */
      void updateDimensions();

    public:
      // @optional
      StateProperty<Camera*> camera;

      // @optional
      StateProperty<float_t> scale;

      /**
       * Create a new PixelPerfectCamera Component.
       * 
       * @param item Item that this component belongs to.
       */
      PixelPerfectCamera(SceneItem *item);
      
      void onStart() override;
  };
}